diff --git a/src/decrypt_keyctl b/src/decrypt_keyctl
index c4dbacb..8b0a15d 100755
--- a/src/decrypt_keyctl
+++ b/src/decrypt_keyctl
@@ -32,8 +32,8 @@ test -x "$STTY_" && PW_READER_='stty'           # 1. backup method
 test -x "$ASKPASS_" && PW_READER_='askpass'     # prefered method
 
 KID_=$(keyctl search @u user "$ID_" 2>/dev/null)
-if [ $? -ne 0 ] || [ -z "$KID_" ]; then
-    # key not found, ask the user
+if [ $? -ne 0 ] || [ -z "$KID_" ] || [ "$CRYPTTAB_TRIED" -gt 0 ]; then
+    # key not found or i've cached wrong key, ask the user
     case "$PW_READER_" in
         askpass)
             KEY_=$($ASKPASS_ "$PROMPT_") || die "Error executing $ASKPASS_"
@@ -66,6 +66,13 @@ if [ $? -ne 0 ] || [ -z "$KID_" ]; then
             fi
             ;;
     esac
+    if [ -n "$KID_" ]; then
+        # I have cached wrong password and now i may use either `keyctl update`
+        # to update $KID_ or just unlink old key, and add new. With `update` i
+        # may hit "Key has expired", though. So i'll go "unlink and add" way.
+        keyctl unlink $KID_ @u
+        KID_=""
+    fi
     KID_=$(echo -n "$KEY_" |keyctl padd user "$ID_" @u)
     [ -z "$KID_" ] && die "Error adding passphrase to kernel keyring"
     if ! keyctl timeout $KID_ $TIMEOUT_; then
